PROGRAM test 
REAL,PARAMETER :: PI = 3.141593
REAL :: in_val[*] 
REAL :: sin_val[*]
INTEGER :: i

IF ( this_image() == 1 ) THEN
   DO i = 1, num_images()-1
      in_val[i+1] = i * PI/2
      SYNC MEMORY
      IF ( i > 0 ) SYNC IMAGES([i+1])
   END DO

ELSE

   SYNC IMAGES([1])

END IF

sin_val = SIN(in_val)
IF ( this_image() > 1 ) THEN

   WRITE (*,'(A,F9.5,A,F9.5)') 'sin(', in_val, ') = ', sin_val
   
END IF

END PROGRAM test
